<div id="selectedColorOutsidePreviewCont" class="alpha-background">
<material-button raised (trigger)="visible=true" [style.background-color]="lastlySelectedColorString" class="selected-color-outside-preview">
</material-button>
</div>
<material-input #colorButtonInput
                floatingLabel
                type="text"
                [(ngModel)]="lastlySelectedColorString"
                label="Selected color"
                (click)="open_dialog($event)">
</material-input>
<material-button id="clearButton" icon (click)="clearSelectedColor()">
    <material-icon icon="close"></material-icon>
</material-button>

<modal [(visible)]="visible">
  <material-dialog headered class="headered-dialog">

    <div id="colorPickerHeader" header>

        <material-list id="colorInputTab">
            <material-list-item [ngClass]="{selectedListItem: isUpperTabSelected('HEX')}" class="no-outline flex-item" (trigger)="updateColorDialogInput(0)">
                <div class="text-center">HEX</div>
            </material-list-item>
            <material-list-item [ngClass]="{selectedListItem: isUpperTabSelected('RGBA')}" class="no-outline flex-item" (trigger)="updateColorDialogInput(1)">
                <div class="text-center">RGBA</div>
            </material-list-item>
            <material-list-item [ngClass]="{selectedListItem: isUpperTabSelected('HSLA')}" class="no-outline flex-item" (trigger)="updateColorDialogInput(2)">
                <div class="text-center">HSLA</div>
            </material-list-item>
        </material-list>

        <div id="colorDialogInputContainer" class="align-center">
            <material-input #colorDiaglogInput
                            class="dialog-color-input"
                            type="text"
                            [(ngModel)]="selectedColorString">
            </material-input>
        </div>

        <div id="colorHolder" class="alpha-background">
            <div id="colorPreview" [style.background]="color">

            </div>
        </div>

    </div>

    <div id="editorContainer" [ngSwitch]="selectedColorTab">
        <div *ngSwitchCase="'HSL'">
            <div id="gradientEditor" class="align-evenly">
                <div id="saturationAndValue" style="position: relative" [ngClass]="{hideCursor: enableMouseTrack}" class="crosshair-cursor">
                    <canvas id="canvasSV" width="230" height="230" class="canvas-border">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                    <canvas id="canvasSVMouse" width="230" height="230" class="canvas-border" style="position: absolute; left: 0px;"
                                     (mousedown)="changeColorSelectState($event)"
                                     (mousemove)="selectColorFromGradient($event)"
                                     (mouseup)="changeColorSelectState($event)">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                </div>
                <div id="hueBar" style="position: relative" [ngClass]="{hideCursor: enableMouseTrack}" class="crosshair-cursor">
                    <canvas id="canvasH" width="40" height="230" class="canvas-border">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                    <canvas id="canvasHMouse" width="40" height="230" class="canvas-border" style="position: absolute; left: 0px;"
                            (mousedown)="changeColorSelectState($event)"
                            (mousemove)="selectColorFromGradient($event)"
                            (mouseup)="changeColorSelectState($event)">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                </div>
                <div id="alphaBar" style="position: relative" [ngClass]="{hideCursor: enableMouseTrack}" class="crosshair-cursor">
                    <canvas id="canvasA" width="40" height="230" class="canvas-border alpha-background">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                    <canvas id="canvasAMouse" width="40" height="230" class="canvas-border" style="position: absolute; left: 0px;"
                            (mousedown)="changeColorSelectState($event)"
                            (mousemove)="selectColorFromGradient($event)"
                            (mouseup)="changeColorSelectState($event)">
                        Your browser does not support the HTML5 canvas tag.
                    </canvas>
                </div>
            </div>
        </div>
        <div *ngSwitchCase="'RGB'">
                <div id="sliderContainer">
                    <material-slider
                            class="red-slider color-slider"
                            [value]="selectedColorR"
                            (valueChange)="changeRGB($event, 0)"
                            [min]="0"
                            [max]="255"
                    ></material-slider>
                        <p>R: {{selectedColorR}}</p>
                    <material-slider
                            class="green-slider color-slider"
                            [value]="selectedColorG"
                            (valueChange)="changeRGB($event, 1)"
                            [min]="0"
                            [max]="255"
                    ></material-slider>
                        <p>G: {{selectedColorG}}</p>
                    <material-slider
                            class="blue-slider color-slider"
                            [value]="selectedColorB"
                            (valueChange)="changeRGB($event, 2)"
                            [min]="0"
                            [max]="255"
                    ></material-slider>
                        <p>B: {{selectedColorB}}</p>
                </div>
        </div>
        <div *ngSwitchCase="'Grid'">
            <div class="color-cont">
                <div *ngFor="let color of listOfMaterialColors" class="value-cont">
                    <div *ngFor="let value of palette.getColorsAvailableValues(color)" class="color-button-cont">
                        <material-button
                                [style.background]="palette.getColor(color, value)"
                                class="color-grid-button"
                                (click)="selectMaterialColor(color, value)"
                        ></material-button>
                    </div>
                </div>
            </div>
        </div>
        <div *ngSwitchCase="'List'">
            <div id="colorListContainer" class="overflow-container">
                <div class="color-cont-list">
                    <div *ngFor="let color of listOfMaterialColors" class="value-cont-list">
                        <div class="color-button-cont-list">
                            <div class="value-cont-list-header" [style.background]="palette.getColorWithMiddleValue(color)">
                                {{palette.getColorName(color)}}
                            </div>
                        </div>
                        <div *ngFor="let value of palette.getColorsAvailableValues(color)" class="color-button-cont-list">
                            <material-button
                                    [style.background]="palette.getColor(color, value)"
                                    class="color-grid-button-list"
                                    (click)="selectMaterialColor(color, value)">
                                {{palette.getValueName(value)}}
                            </material-button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div *ngSwitchCase="'History'">
            <div id="colorHistory" class="overflow-container">
                <div *ngFor="let colorHexString of colorHistory.keys" class="color-cont-history">
                    <material-button
                            [style.background]="'#'+colorHexString"
                            class="color-grid-button-list color-grid-button-history"
                            (click)="selectPreviousColor(colorHexString)">
                        {{colorHexString}}
                    </material-button>
                </div>
            </div>
        </div>
        <div *ngSwitchDefault>
          <div>default page</div>
        </div>
    </div>


    <material-list id="editorTab">
        <material-list-item [ngClass]="{selectedListItem: isTabSelected('HSL')}" class="no-outline" (trigger)="selectTab('HSL')">
            <material-icon icon="gradient"></material-icon>
        </material-list-item>
        <material-list-item [ngClass]="{selectedListItem: isTabSelected('RGB')}" class="no-outline" (trigger)="selectTab('RGB')">
            <material-icon icon="tune"></material-icon>
        </material-list-item>
        <material-list-item [ngClass]="{selectedListItem: isTabSelected('Grid')}" class="no-outline" (trigger)="selectTab('Grid')">
            <material-icon icon="view_module"></material-icon>
        </material-list-item>
        <material-list-item [ngClass]="{selectedListItem: isTabSelected('List')}" class="no-outline" (trigger)="selectTab('List')">
            <material-icon icon="view_list"></material-icon>
        </material-list-item>
        <material-list-item [ngClass]="{selectedListItem: isTabSelected('History')}" class="no-outline" (trigger)="selectTab('History')">
            <material-icon icon="history"></material-icon>
        </material-list-item>
    </material-list>

    <div id="colorPickerFooter" footer>
      <material-button class="text_white" autoFocus clear-size (click)="cancel()">
        Cancel
      </material-button>
      <material-button class="text_white" autoFocus clear-size (click)="selectColor()">
        Select
      </material-button>
    </div>

  </material-dialog>
</modal>